// hook.cpp : DLL AvP[Vp̃Gg |Cg`܂B
//

#include "stdafx.h"

HINSTANCE g_hinstThisDLL = NULL;		// DLL̃CX^Xnh

#pragma data_seg(".shared")			// Lf[^
HHOOK g_hhookCallWndRetProc = NULL;	// tbÑnh
HWND g_hWndRecevier = NULL;			// bZ[W󂯎EBhE
UINT g_uMessage = 0;				// bZ[Wԍ
#pragma data_seg()
#pragma comment(linker, "/SECTION:.shared,rws")

/////////////////////////////////////////////////////////////////////////////
// fobO

#ifdef _DEBUG
void DbgPrintf(LPTSTR fmt, ...)
{
	va_list marker;
	TCHAR szBuf[2048] = "hook.dll: ";
	
	va_start(marker, fmt);
	wvsprintf(szBuf + strlen(szBuf), fmt, marker);
	va_end(marker);
	
	OutputDebugString(szBuf);
	OutputDebugString(TEXT("\r\n"));
}
#else
inline void DbgPrintf(LPTSTR fmt, ...)
{
}
#endif

/////////////////////////////////////////////////////////////////////////////
// DLLGg

#ifdef __cplusplus
extern "C"
#endif
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	DbgPrintf("DllMain(0x%lX, 0x%lX, 0x%lX)", (long) hinstDLL, (long) fdwReason, (long) lpvReserved);
	
	switch(fdwReason) {
	case DLL_PROCESS_ATTACH:
		g_hinstThisDLL = hinstDLL;
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		break;
	default:
		_ASSERT(FALSE);
	}
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// tbNvVW

void SendIMEStatus(HWND hWnd, DWORD dwStatus = 0)
{
	DbgPrintf("SendIMEStatus");
	
	HWND hWndRoot = ::GetAncestor(hWnd, GA_ROOT);
	if (hWndRoot != ::GetForegroundWindow())
		return;
	hWnd = ::GetFocus();
	
	if (hWnd != NULL) {
		HIMC himc = ::ImmGetContext(hWnd);
		if (himc) {
			if (::ImmGetOpenStatus(himc))
				dwStatus |= ISN_OPEN;
			::ImmReleaseContext(hWnd, himc);
		} else {
			hWnd = NULL;
		}
	}
	DbgPrintf("PostMessage(0x%lX, 0x%lX, 0x%lX, 0x%lX)", (long) g_hWndRecevier, (long) g_uMessage, (long) hWnd, (long) dwStatus);
	::PostMessage(g_hWndRecevier, g_uMessage, (WPARAM) hWnd, (LPARAM) dwStatus);
}

void OnMessage(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) {
	case WM_IME_NOTIFY:
		DbgPrintf("OnMessage:WM_IME_NOTIFY(0x%lX)", (long) wParam);
		switch (wParam) {
		case IMN_OPENSTATUSWINDOW:
		case IMN_CLOSESTATUSWINDOW:
		case IMN_SETOPENSTATUS:
			SendIMEStatus(hWnd);
			break;
		}
		break;
	case WM_ACTIVATE:
		switch (wParam) {
		case WA_ACTIVE:
		case WA_CLICKACTIVE:
			SendIMEStatus(hWnd);
			break;
		}
		break;
	case WM_SETFOCUS:
		SendIMEStatus(hWnd);
		break;
	case WM_SIZE:
	case WM_MOVE:
		SendIMEStatus(hWnd, ISN_POSITION_CHANGED);
		break;
	}
}

LRESULT CALLBACK CallWndRetProc(int code, WPARAM wParam, LPARAM lParam)
{
	const CWPRETSTRUCT* pCwpr = (const CWPRETSTRUCT*) lParam;
	//if (code == HC_ACTION)
		OnMessage(pCwpr->hwnd, pCwpr->message, pCwpr->wParam, pCwpr->lParam);
	return CallNextHookEx(g_hhookCallWndRetProc, code, wParam, lParam);
}


/////////////////////////////////////////////////////////////////////////////
// tbN

BOOL IsHooked(void)
{
	return g_hhookCallWndRetProc != NULL;
}

BOOL Hook(void)
{
	if (IsHooked())
		return TRUE;
	
	if (g_hhookCallWndRetProc == NULL)
		g_hhookCallWndRetProc = SetWindowsHookEx(WH_CALLWNDPROCRET, (HOOKPROC) CallWndRetProc, g_hinstThisDLL, 0);
	
	return g_hhookCallWndRetProc != NULL;
}

BOOL Unhook(void)
{
	if (!IsHooked())
		return TRUE;
	
	if (g_hhookCallWndRetProc != NULL) {
		if(UnhookWindowsHookEx(g_hhookCallWndRetProc))
			g_hhookCallWndRetProc = NULL;
	}
	return g_hhookCallWndRetProc == NULL;
}

/////////////////////////////////////////////////////////////////////////////
// Gg

BOOL __stdcall HookDLL_SetReceiverWindow(HWND hWndRecevier, UINT uMessage)
{
	DbgPrintf("HookDLL_SetReceiverWindow(0x%lX, 0x%lX)", (long) hWndRecevier, (long) uMessage);
	
	if (!Unhook())
		return FALSE;
	
	g_hWndRecevier = hWndRecevier;
	g_uMessage = uMessage;
	
	if (hWndRecevier != NULL) {
		if (!Hook())
			return FALSE;
	}
	
	return TRUE;
}

