// TwinkleIME.cpp : AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"
#include "resource.h"

#define TIMERID_KICK 1
#define TIMERID_ANIMATION 2

// O[oϐ:
HINSTANCE g_hInst;						// ݂̃CX^X
TCHAR g_szIniFile[_MAX_PATH + 1];
TCHAR g_szWindowClass[] = _T("TWINKLEIME");
HICON g_hIcon = NULL;
UINT g_nMillisecondsKick = 100;
UINT g_nMillisecondsPerFrame = 100;
UINT g_nMillisecondsPerCycle = 1600;
UINT g_nMillisecondsPerCycleLightweightMode = 5000;

UINT_PTR g_nTimer = 0;
DWORD g_AnimationBaseTime = 0;
HWND g_hWndActive = NULL;
RECT g_rectActiveWindow;
RECT g_rectFrameWindow;
int g_alphaOfWindow = -1;

// ̃R[h W[Ɋ܂܂֐̑O錾:
ATOM MyRegisterClass( HINSTANCE hInstance );
BOOL InitInstance( HINSTANCE, int );
LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );
LRESULT CALLBACK About( HWND, UINT, WPARAM, LPARAM );

#ifdef _DEBUG
void DbgPrintf(LPTSTR fmt, ...)
{
	va_list marker;
	TCHAR szBuf[2048] = "TwinkleIME.exe: ";
	
	va_start(marker, fmt);
	wvsprintf(szBuf + strlen(szBuf), fmt, marker);
	va_end(marker);
	
	OutputDebugString(szBuf);
	OutputDebugString(TEXT("\r\n"));
}
#else
inline void DbgPrintf(LPTSTR fmt, ...)
{
}
#endif


int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	// TODO: ̈ʒuɃR[hLqĂB
	MSG msg;
	
	{
		DWORD len = GetModuleFileName(hInstance, g_szIniFile, sizeof(g_szIniFile) / sizeof(g_szIniFile[0]) - 1);
		g_szIniFile[len] = _T('\0');
		_TCHAR* p = _tcsrchr(g_szIniFile, _T('.'));
		if (p) {
			_tcscpy(p, _T(".ini"));
		} else {
			g_szIniFile[0] = _T('\0');
		}
		
		g_nMillisecondsKick = GetPrivateProfileInt(_T("TwinkleIMEObserver"), _T("MillisecondsKick"), g_nMillisecondsKick, g_szIniFile);
		g_nMillisecondsPerFrame = GetPrivateProfileInt(_T("TwinkleIMEObserver"), _T("MillisecondsPerFrame"), g_nMillisecondsPerFrame, g_szIniFile);
		g_nMillisecondsPerCycle = GetPrivateProfileInt(_T("TwinkleIMEObserver"), _T("MillisecondsPerCycle"), g_nMillisecondsPerCycle, g_szIniFile);
		g_nMillisecondsPerCycleLightweightMode = GetPrivateProfileInt(_T("TwinkleIMEObserver"), _T("MillisecondsPerCycleLightweightMode"), g_nMillisecondsPerCycleLightweightMode, g_szIniFile);
	}
	
	MyRegisterClass( hInstance );
	
	// AvP[V̏s܂:
	if( !InitInstance( hInstance, nCmdShow ) ) 
	{
		return FALSE;
	}
	
	// C bZ[W [v:
	while( GetMessage(&msg, NULL, 0, 0) ) 
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}
	
	return msg.wParam;
}



//
//  ֐: MyRegisterClass()
//
//  pr: EBhE NX̓o^
//
//  Rg:
//
//    ̊֐т̎gp͂̃R[h Windows 95 Őɒǉꂽ
//    'RegisterClassEx' ֐ Win32 VXě݊ێꍇ
//    ̂ݕKvƂȂ܂BAvP[VAAvP[VɊ֘At
//    ꂽX[ ACR擾ł悤Å֐ĂяoƂ
//    dvłB
//
ATOM MyRegisterClass( HINSTANCE hInstance )
{
	WNDCLASSEX wcex = { 0 };
	
	wcex.cbSize = sizeof(WNDCLASSEX); 
	
	wcex.style      = CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc    = (WNDPROC)WndProc;
	wcex.cbClsExtra     = 0;
	wcex.cbWndExtra     = 0;
	wcex.hInstance      = hInstance;
	wcex.hIcon			= NULL;
	wcex.hCursor        = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground  = CreateSolidBrush(GetPrivateProfileInt(_T("TwinkleIMEObserver"), _T("Color"), RGB(0xFF, 0, 0), g_szIniFile));
	wcex.lpszMenuName   = NULL;
	wcex.lpszClassName  = g_szWindowClass;
	wcex.hIconSm        = NULL;
	
	return RegisterClassEx( &wcex );
}

//
//   ֐: InitInstance(HANDLE, int)
//
//   pr: CX^X nh̕ۑƃC EBhE̍쐬
//
//   Rg:
//
//        ̊֐ł́ACX^X nhO[oϐɕۑAvO
//        C EBhE쐬\܂B
//
BOOL InitInstance( HINSTANCE hInstance, int nCmdShow )
{
	HWND hWnd;
	
	g_hInst = hInstance; // O[oϐɃCX^X nhۑ܂
	
	hWnd = CreateWindowEx(WS_EX_TOPMOST | WS_EX_NOACTIVATE | WS_EX_LAYERED, g_szWindowClass, _T("TwinkleIME"), WS_POPUP, CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);
	
	if( !hWnd ) 
	{
		return FALSE;
	}
	
	HookDLL_SetReceiverWindow(hWnd, WM_IME_STATUS_NOTIFY);
	
    g_hIcon = (HICON) LoadImage(hInstance, MAKEINTRESOURCE(IDI_TWINKLEIME), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
	
	NOTIFYICONDATA nid = { 0 };
	nid.cbSize = sizeof(nid);
	nid.hWnd = hWnd;
	nid.uID = 0;
	nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	nid.uCallbackMessage = WM_NOTIFY_ICON;
	nid.hIcon = g_hIcon;
	_tcscpy(nid.szTip, _T("TwinkleIME - Click to Exit"));
	Shell_NotifyIcon(NIM_ADD, &nid);
	
	return TRUE;
}

void SetTimer(HWND hWnd, BOOL active)
{
	if (active) {
		DbgPrintf(_T("SetTimer(TRUE)"));
		if (g_nTimer == 0)
			g_nTimer = SetTimer(hWnd, TIMERID_ANIMATION, g_nMillisecondsPerFrame, NULL);
	} else {
		DbgPrintf(_T("SetTimer(FALSE)"));
		if (g_nTimer != 0) {
			KillTimer(hWnd, g_nTimer);
			g_nTimer = 0;
		}
	}
}
void KickTimer(HWND hWnd)
{
	DbgPrintf(_T("KickTimer"));
	SetTimer(hWnd, FALSE);
	g_nTimer = SetTimer(hWnd, TIMERID_KICK, g_nMillisecondsKick, NULL);
}

LRESULT CALLBACK OnIMEStatusNotify(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	HWND hWndActive = (HWND) wParam;
	DWORD dwStates = (DWORD) lParam;
	
	DbgPrintf(_T("OnIMEStatusNotify(0x%lX, 0x%lX)"), (long) hWndActive, (long) dwStates);
	
	if (hWndActive == hWnd)
		return 0;
	
	/*if (GetAncestor(hWndActive, GA_ROOT) == hWnd)
		return 0;*/
	
	if (dwStates & ISN_OPEN) {
		if ((dwStates & ISN_POSITION_CHANGED) || hWndActive != g_hWndActive) {
			g_hWndActive = hWndActive;
			KickTimer(hWnd);
		}
	} else {
		SetTimer(hWnd, FALSE);
		SetWindowPos(hWnd, HWND_BOTTOM, 0, 0, 0, 0, SWP_NOACTIVATE | SWP_NOCOPYBITS | SWP_NOMOVE | SWP_NOREDRAW | SWP_HIDEWINDOW);
		//ShowWindow(hWnd, SW_HIDE);
		g_alphaOfWindow = 0;
		g_hWndActive = NULL;
	}
	
	return 0;
}

LRESULT CALLBACK OnTimer(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	UINT timerID = wParam;
	if (timerID == TIMERID_KICK) {
		DbgPrintf(_T("OnTimer(TIMERID_KICK)"));
		g_AnimationBaseTime = GetTickCount();
		SetTimer(hWnd, FALSE);
		SetTimer(hWnd, TRUE);
		
		HWND hWndActive = g_hWndActive;
		if (hWndActive == NULL)
			return 0;
		
		RECT rect;
		{
			GetClientRect(hWndActive, &rect);
			POINT pt = { 0, 0 };
			ClientToScreen(hWndActive, &pt);
			rect.left += pt.x;
			rect.right += pt.x;
			rect.top += pt.y;
			rect.bottom += pt.y;
		}
		
		if (memcmp(&rect, &g_rectActiveWindow, sizeof(RECT)) != 0) {
			DbgPrintf(_T("OnTimer: MoveWindow"));
			g_rectActiveWindow = rect;
			
			int edge = 0;
			int width = 3;
			if (rect.bottom - rect.top <= 32 || rect.right - rect.left <= 32) {
				int drift = width;
				rect.top -= drift;
				rect.left -= drift;
				rect.right += drift;
				rect.bottom += drift;
			}
			g_rectFrameWindow = rect;
			int cut = 0;	// edge + width;
			
			if (true) {
				SetWindowPos(hWnd, HWND_BOTTOM, g_rectFrameWindow.left, g_rectFrameWindow.top, g_rectFrameWindow.right - g_rectFrameWindow.left, g_rectFrameWindow.bottom - g_rectFrameWindow.top, SWP_NOACTIVATE | SWP_NOCOPYBITS | SWP_HIDEWINDOW);
			} else {
				MoveWindow(hWnd, g_rectFrameWindow.left, g_rectFrameWindow.top, g_rectFrameWindow.right - g_rectFrameWindow.left, g_rectFrameWindow.bottom - g_rectFrameWindow.top, TRUE);
				ShowWindow(hWnd, SW_HIDE);
			}
			g_alphaOfWindow = 0;
			
			rect.right -= rect.left;
			rect.left -= rect.left;
			rect.bottom -= rect.top;
			rect.top -= rect.top;
			HRGN hrgnDst = CreateRectRgn(rect.left + edge, rect.top + cut, rect.left + edge + width, rect.bottom - cut);
			HRGN hrgnSrc = CreateRectRgn(rect.right - edge - width, rect.top + cut, rect.right - edge, rect.bottom - cut);
			CombineRgn(hrgnDst, hrgnDst, hrgnSrc, RGN_OR);
			DeleteObject(hrgnSrc);
			hrgnSrc = CreateRectRgn(rect.left + cut, rect.top + edge, rect.right - cut, rect.top + edge + width);
			CombineRgn(hrgnDst, hrgnDst, hrgnSrc, RGN_OR);
			DeleteObject(hrgnSrc);
			hrgnSrc = CreateRectRgn(rect.left + cut, rect.bottom - edge - width, rect.right - cut, rect.bottom - edge);
			CombineRgn(hrgnDst, hrgnDst, hrgnSrc, RGN_OR);
			DeleteObject(hrgnSrc);
			SetWindowRgn(hWnd, hrgnDst, TRUE);
		}
	}
	
	SYSTEM_POWER_STATUS systemPowerStatus;
	BOOL fLightweight = GetSystemMetrics(SM_REMOTESESSION) || (GetSystemPowerStatus(&systemPowerStatus) && systemPowerStatus.ACLineStatus == 0);
	
	int alpha;
	if (!fLightweight) {
		UINT loopMS = g_nMillisecondsPerCycle;
		if (loopMS == 0) {
			alpha = 0x80;
		} else {
			double ratio = 2 * ((GetTickCount() - g_AnimationBaseTime) % loopMS) / (double) loopMS;	// ratio = 0...2
			if (ratio > 1)
				ratio = 2 - ratio;				// 0...1...0
			ratio = 1 - ratio;					// 1...0...1
			alpha = (int) (ratio * 255);
		}
	} else {
		UINT loopMS = g_nMillisecondsPerCycleLightweightMode;
		if (loopMS == 0) {
			alpha = 0x80;
		} else {
			double ratio = 5 * ((GetTickCount() - g_AnimationBaseTime) % loopMS) / (double) loopMS;	// ratio = 0...3
			alpha = (ratio < 3) ? 255 : 0;
		}
	}
	DbgPrintf(_T("OnTimer: alpha=%d"), (int) alpha);
	if (g_alphaOfWindow != alpha) {
		if (alpha == 0) {
			DbgPrintf(_T("OnTimer: ShowWindow(SW_HIDE)"));
			ShowWindow(hWnd, SW_HIDE);
		} else {
			DbgPrintf(_T("OnTimer: SetLayeredWindowAttributes"));
			SetLayeredWindowAttributes(hWnd, 0, alpha, LWA_ALPHA);
			if (g_alphaOfWindow == 0) {
				SetWindowPos(hWnd, HWND_TOPMOST, g_rectFrameWindow.left, g_rectFrameWindow.top, g_rectFrameWindow.right - g_rectFrameWindow.left, g_rectFrameWindow.bottom - g_rectFrameWindow.top, SWP_NOACTIVATE | SWP_NOCOPYBITS | SWP_SHOWWINDOW);
				//ShowWindow(hWnd, SW_SHOWNOACTIVATE);
			}
		}
		g_alphaOfWindow = alpha;
	}
	
	return 0;
}

LRESULT CALLBACK OnNotifyIcon(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
    switch(lParam) {
		case WM_RBUTTONUP:
		case WM_MBUTTONUP:
		case WM_LBUTTONUP:
		case WM_CONTEXTMENU:
			DestroyWindow( hWnd );
			break;
	}
	return 0;
}

/*LRESULT CALLBACK OnPaint(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	HDC hdc = BeginPaint(hWnd, &ps);
	
	RECT rt;
	GetClientRect(hWnd, &rt);
	
	//FillRect(hdc, &rt, g_hRedBrush);
	
	EndPaint(hWnd, &ps);
	return 0;
}*/

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch( message ) 
	{
		/*case WM_PAINT:
			return OnPaint(hWnd, wParam, lParam);*/
		case WM_DESTROY:
			SetTimer(hWnd, FALSE);
			HookDLL_SetReceiverWindow(NULL, 0);
			{
				NOTIFYICONDATA nid = { 0 };
				nid.cbSize = sizeof(nid);
				nid.hWnd = hWnd;
				nid.uID = 0;
				Shell_NotifyIcon(NIM_DELETE, &nid);
			}
			DestroyIcon(g_hIcon);
			PostQuitMessage( 0 );
			break;
		case WM_IME_STATUS_NOTIFY:
			return OnIMEStatusNotify(hWnd, wParam, lParam);
		case WM_NOTIFY_ICON:
			return OnNotifyIcon(hWnd, wParam, lParam);
		case WM_TIMER:
			return OnTimer(hWnd, wParam, lParam);
		default:
			return DefWindowProc( hWnd, message, wParam, lParam );
	}
	return 0;
}

// o[W{bNXpbZ[W nh
LRESULT CALLBACK About( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch( message )
	{
	case WM_INITDIALOG:
		return TRUE;
		
	case WM_COMMAND:
		if( LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL ) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}
